/**
Network server to demonstrate buffer overflow attack.

This server is run:
	- As a no-privilege user.
	- In a "chroot" jail.
	- Inside an emulated machine.
So you really can't make too much trouble here.

Orion Sky Lawlor, olawlor@acm.org, 2006/2/5 (Public Domain)
*/
#include <stdio.h>
#include <signal.h>
#include "osl/socket.h"
#include "osl/socket.cpp" /* include body for easy linking */

/* Socket to communicate results back to sender */
SOCKET s;

/** Request data sent across network */
std::string user, req;

/** Final output routine--stores homework grade. 
To get an A, you'll have to call this subroutine
with a pointer to a string starting with "A".
*/
void grade(const char *state) {
	/** Store result in grading file */
	FILE *f=fopen("grade","w");
	if (f==NULL) printf("Can't create grade file...\n");
	else {
		fprintf(f,"User:'%s' Grade:'%s'\n",user.c_str(),state);
		fclose(f);
	}
	/** Send results back to user */
	skt_sendN(s,state,strlen(state));
	char newline='\n'; /* always terminate results with newline */
	skt_sendN(s,&newline,1);
	skt_close(s);
	exit(0);
}

/** "B" string.  You've got to figure out how
to pass this as an argument to the "grade" routine. 
*/
const char *grade_B="B--passed grade_B string";

/** "C" routine: if control gets here, calls grade("C"); 
*/
void grade_C(void) {
	grade("C--called grade_C routine");
}

/* Respond to various error conditions with a "D" grade */
void segfault_fn(int ignored) {grade("D--segfault");}
void sigill_fn(int ignored) {grade("D--illegal instruction");}
void hang_fn(int ignored) {grade("D--hang/too slow");}

/** VULNERABLE routine */
void parse_request(void)
{
	char buf[32];
	printf("Inside vulnerable routine:\n"
		"	grade_C routine is at %p\n"
		"	grade_B string is at %p\n"
		"	grade routine is at %p\n"
		"	buf is at %p\n",
		grade_C, grade_B, grade, buf);
	strcpy(buf,req.c_str());
}

int main(int argc,char *argv[])
{
	char buf[6];
	unsigned int port=1235; /* use 0 to have OS pick a port */
	SERVER_SOCKET serv=skt_server(&port);
	printf("Waiting for connect on port %d\n",port);
	skt_ip_t client_ip; unsigned int client_port;
	s=skt_accept(serv,&client_ip,&client_port);
	skt_close(serv);
	
	signal(SIGSEGV,segfault_fn); /* install segfault signal handler */
	signal(SIGILL,sigill_fn);
	signal(SIGALRM,hang_fn);
	alarm(2); /* better finish up within 2 seconds */

// Grab data from user:	
	user=skt_recv_line(s); /* User name */
	printf("Received request from user '%s'\n",user.c_str());
	if (user.size()>8u) exit(1); /* fsabc12 */
	req=skt_recv_line(s); /* request */
	printf("Received %d-byte request\n",req.size());
	
	/** Store attack */
	FILE *f=fopen("req.bin","wb");
	if (f==NULL) printf("Can't create req.bin file...\n");
	else {
		fwrite(&req[0],req.size(),1,f);
		fclose(f);
	}
	
// Handle network data in an unsafe way:
	parse_request();
	grade("F--no crash"); /* survived parsing */
	return 0;
}
